<template>
  <section class="container">
    <div v-if="test && question && answers">
      <h1 class="test-title">{{test.name}}</h1>
      <div class="progress">
        <div
          class="progress-bar bg-success"
          role="progressbar"
          v-bind:style="{ width: progress + '%' }"
          v-bind:aria-valuenow="progress"
          aria-valuemin="0"
          aria-valuemax="100"
        ></div>
      </div>
      <h3 class="question mt-3">{{question.text}}</h3>
      <div class="row mr-0">
        <div class="col-sm-6" v-for="answer in answers" :key="answer._id">
          <button
            type="button"
            class="btn btn-lg btn-block m-2"
            v-on:click="selectAnswer(answer._id)"
            v-bind:class="{active: false, 'btn-primary': !isSelected(answer._id), 'btn-success': isSelected(answer._id)}"
          >{{answer.text}}</button>
        </div>
      </div>
      <div>
        <button class="btn btn-success btn-block mt-3" v-on:click="next()">{{nextBtnTxt}}</button>
      </div>
    </div>
  </section>
</template>

<script>
export default {
  beforeRouteEnter(to, from, next) {
    next(vm => {
      const data = vm.$store.state.test;
      if (!vm.validateResult(data)) {
        vm.$router.push("/");
      }
    });
  },
  created() {
    this.fetchQuestion(
      this.$store.state.test.testId,
      this.$store.state.test.currentQuestionIdx
    );
  },
  data: function() {
    return {
      selectedAnswer: "",
      test: null,
      question: null,
      questionIdx: Number(this.$store.state.test.currentQuestionIdx),
      questionCnt: null,
      answers: []
    };
  },
  computed: {
    nextBtnTxt: function() {
      return this.$data.questionIdx === this.$data.questionCnt
        ? "Aplūkot rezultātus"
        : "Nākamais jautājums";
    },
    progress: function() {
      if (this.questionCnt > 0) {
        return (this.questionIdx / this.questionCnt) * 100;
      }
      return 0;
    }
  },
  methods: {
    selectAnswer(id) {
      this.$data.selectedAnswer = id;
    },
    isSelected(id) {
      return this.$data.selectedAnswer === id;
    },
    async next() {
      if (this.$data.selectedAnswer !== "") {
        // update testResult entry
        const testResult = await this.$axios.$put(
          process.env.apiUrl + "tests/submit",
          {
            resultId: this.$store.state.test.resultId,
            questionId: this.$data.question._id,
            selectedAnswer: this.$data.selectedAnswer
          }
        );
        // update store
        await this.$store.commit(
          "test/nextQuestion",
          testResult.currentQuestionIdx
        );
        if (testResult.currentQuestionIdx !== -1) {
          this.fetchQuestion(
            this.$store.state.test.testId,
            this.$store.state.test.currentQuestionIdx
          );
        } else {
          this.$router.push("/results"); // goto finish
        }
      } else {
        this.$notify({
          title: "Uzmanību!",
          text:
            "Lai turpinātu, nepieciešams izvēlēties vienu no piedāvātajiem atbildes variantiem!"
        });
      }
    },
    async fetchQuestion(testId, questionIdx) {
      const data = await this.$axios.$get(
        process.env.apiUrl + "tests/" + testId + "/questions/" + questionIdx
      );
      this.$data.test = data.test;
      this.$data.question = data.question;
      this.$data.questionCnt = data.questionCnt;
      this.$data.answers = data.answers;
      this.$data.questionIdx = questionIdx;
      this.$data.selectedAnswer = "";
    },
    validateResult(data) {
      return (
        data.userName !== "" &&
        data.testId !== "" &&
        data.resultId !== "" &&
        data.currentQuestionIdx > 0
      );
    }
  }
};
</script>

<style>
.container {
  margin: 0 auto;
  min-height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  text-align: center;
}

.test-title {
  font-family: "Quicksand", "Source Sans Pro", -apple-system, BlinkMacSystemFont,
    "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif;
  display: block;
  font-weight: 300;
  /* font-size: 100px; */
  color: #35495e;
  letter-spacing: 1px;
}

.question {
  font-family: "Quicksand", "Source Sans Pro", -apple-system, BlinkMacSystemFont,
    "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif;
  display: block;
  font-weight: 300;
  /* font-size: 100px; */
  color: #35495e;
  letter-spacing: 1px;
}
</style>
